#include "Tank.h"

#ifndef EnemyTank_h
#define EnemyTank_h

class EnemyTank : public Tank {   
private:
		void procForceAtack(Tank &tank){
		rotate = direction(tank) + rand()%10-5;
		move(0.5);
	}

	void procNormalAtack(Tank &tank){
		// ピンチになったら逃げ惑う
//        if (life < maxLife/5) {
//            isDanger = true;
//            last_safe_time = global_time;
//        }
        
        if (isDanger == false) {
            // 自機に玉があたる方向を向く
            float diff = direction(tank);
            
            if(enemy_level >= 9){
                if(abs(diff - rotate) > abs(diff+60 - rotate)) diff += 60;
                else if(abs(diff - rotate) > abs(diff-60 - rotate)) diff -= 60;
                else if(abs(diff - rotate) > abs(diff+90 - rotate)) diff += 90;
                else if(abs(diff - rotate) > abs(diff-90 - rotate)) diff -= 90;
                else if(abs(diff - rotate) > abs(diff+180 - rotate)) diff += 180;
            }else if(enemy_level >= 6){
                if(abs(diff - rotate) > abs(diff+60 - rotate)) diff += 60;
                else if(abs(diff - rotate) > abs(diff-60 - rotate)) diff -= 60;
                else if(abs(diff - rotate) > abs(diff+180 - rotate)) diff += 180;
            }else if(enemy_level >= 3){
                if(abs(diff - rotate) > abs(diff+180 - rotate)) diff += 180;
            }
            
            // 少しだけ散乱させて避けにくくする
            rotate = diff + (rand()%30 - 15);
            
        }

        if(isDanger == false){
           move(0.3);
            
            for(int i=0; i<tank.tid; i++){
                // 近くに来ている自機の玉
                if(tank.ball[i].isExist == true){
                    float d = distance(tank.ball[i]);
                    
                    if (d < 2.5) {
                        isDanger = true;
                        last_safe_time = global_time;
                        if(enemy_level < 6){
                            // あたらない方向にちょっとだけ瞬間移動する
                            rotate = direction(ball[i]);
                            rotate += rand()%100 < 50 ? 90 : -90;
                            
                            move(0.1 * enemy_level);
                        }
                        break;
                    }else if(d < 4.0){
                        move(-0.6);
                        break;
                    }
                }
            }            
        }else{
            // 強制完全回避モード
            if(global_time - last_safe_time < 10+2*enemy_level){
                rotate += rand()%6-3;
                float max = 0.5 + enemy_level/40;
                if (life < maxLife/5) {
                    max *= 3;
                }

                for (float step=max; step>=-max; step-=0.1) {
                    bool moved = true;
                    move(step);
					if(!isInField()){
						move(-step);
						continue;
					}
                    
                    for(int i=0; i<tank.tid; i++){
                        // 近くに来ている自機の玉
                        if(tank.ball[i].isExist == true){
                            float d = distance(tank.ball[i]);
                            if (d < 2.0){
                                move(-step);
                                moved = false;
                                break;
                            }
                        }
                    }
                    if (moved) {
						//validatePosition();
                        break;
                    }
                }
            }else{
                isDanger = false;
            }
        }
	}

public:
	bool isDanger; // 危険なときtrue
	int last_safe_time; // 最後に安全モードだった時刻
    
    EnemyTank(){
        reset();
    }
    
    void reset(int initType){
        reset();
        type = initType;
    }
    
    void reset(){
        Tank::reset();
        
        //z = -13;
        z = -rand()%16;
        x = rand()%32-16;
        
        type = ENEMY;
        last_safe_time = global_time;
        isDanger = false;
    }
    
    // EnemyTankは相手の行動を元に自らの行動を決定する
	void proc(Tank &tank){
        Tank::proc(tank);
        
        if(!isExist || !tank.isExist) return;
        
		// ライフに圧倒的な差があったら特攻する
		if(life > tank.life*2 && life - tank.life > 10){
			procForceAtack(tank);
		}else{
			procNormalAtack(tank);
		}
        
        
        // 画面外から出ないようにする
        if(x > 15.5){
            x -= 0.5;
            //rotate = rand()%360-720;
            rotate = direction(tank);
            rotate += rand()%100 < 50 ? 90 : -90;
        }else if(x < -15.5){
            x += 0.5;
            //rotate = rand()%360-720;
            rotate = direction(tank);
            rotate += rand()%100 < 50 ? 90 : -90;
        }
        if(z > 15.5){
            z -= 0.5;
            //rotate = rand()%360-720;
            rotate = direction(tank);
            rotate += rand()%100 < 50 ? 90 : -90;
        }else if(z < -15.5){
            z += 0.5;
            //rotate = rand()%360-720;
            rotate = direction(tank);
            rotate += rand()%100 < 50 ? 90 : -90;
        }
        
        // 射撃
		shoot();
    }
    
};

#endif



